InheritableThreadLocal (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang, class: InheritableThreadLocal
Keywords: java.lang.InheritableThreadLocal class

# Class InheritableThreadLocal<T>

java.lang.Object
java.lang.ThreadLocal<T>
java.lang.InheritableThreadLocal<T>

Type Parameters:
  `T` - the type of the inheritable thread local's value

public class InheritableThreadLocal<T> extends ThreadLocal<T>
This class extends `ThreadLocal` to provide inheritance of values from parent thread to child thread: when a child thread is created, the child receives initial values for all inheritable thread-local variables for which the parent has values. Normally the child's values will be identical to the parent's; however, the child's value can be made an arbitrary function of the parent's by overriding the `childValue` method in this class.

Inheritable thread-local variables are used in preference to ordinary thread-local variables when the per-thread-attribute being maintained in the variable (e.g., User ID, Transaction ID) must be automatically transmitted to any child threads that are created.

Note: During the creation of a new `thread`, it is possible to opt out of receiving initial values for inheritable thread-local variables.

Since:
  1.2
See Also:
  - `ThreadLocal`
  - `Thread.Builder.inheritInheritableThreadLocals(boolean)`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `InheritableThreadLocal()`
  Creates an inheritable thread local variable.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected T`
  `childValue(T parentValue)`
  Computes the child's initial value for this inheritable thread-local variable as a function of the parent's value at the time the child thread is created.

  ### Methods declared in class ThreadLocal

  `get, initialValue, remove, set, withInitial`
  Modifier and Type
  Method
  Description
  `T`
  `get()`
  Returns the value in the current thread's copy of this thread-local variable.
  `protected T`
  `initialValue()`
  Returns the current thread's "initial value" for this thread-local variable.
  `void`
  `remove()`
  Removes the current thread's value for this thread-local variable.
  `void`
  `set(T value)`
  Sets the current thread's copy of this thread-local variable to the specified value.
  `static <S> ThreadLocal<S>`
  `withInitial(Supplier<? extends S> supplier)`
  Creates a thread local variable.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### InheritableThreadLocal

    public InheritableThreadLocal()
    Creates an inheritable thread local variable.

- ## Method Details

  - ### childValue

    protected T childValue(T parentValue)
    Computes the child's initial value for this inheritable thread-local variable as a function of the parent's value at the time the child thread is created. This method is called from within the parent thread before the child is started.

    This method merely returns its input argument, and should be overridden if a different behavior is desired.

    Parameters:
      `parentValue` - the parent thread's value
    Returns:
      the child thread's initial value